#include "initng_ngc3.h"

#include "../../src/initng_list.h"

#include <getopt.h>
#include <stdio.h>
#include <stdlib.h>

static struct option const long_options[] = { {"reboot", 0, NULL, '0'},
{"halt", 0, NULL, '6'},
{"start", 1, NULL, 'u'},
{"stop", 1, NULL, 'd'},
{"restart", 1, NULL, 'r'},
{"status", 0, NULL, 's'},
{NULL, 0, NULL, 0}
};
static char const *const short_options = "06u:d:r:s";

struct ngc_command_list_node
{
    struct ngc_command *cmd_ptr;
    struct list_head list;
};

static struct ngc_command_list_node ngc_commands;
static int ngc_msg;

static void process_command(struct ngc_command *cmd_ptr)
{
    printf("%c: %s\n", cmd_ptr->type, cmd_ptr->service);
}

static int init(void)
{
    INIT_LIST_HEAD(&ngc_commands.list);

    /*
       ngc_msg = msgget(ftok(FTOK_FILE, FTOK_PROJ), 0600);
       if(ngc_msg == -1) {
       fputs("Unable to open message queue to initng.\n", stderr);
       return -1;
       }
     */
    return 0;
}

int main(int argc, char *argv[])
{
    int c, opt_ix;
    struct ngc_command *cmd_ptr;
    struct ngc_command_list_node *current;

    if (init() != 0)
    {
        fputs("Initialization failed.\n", stderr);
        return -1;
    }

    while ((c =
            getopt_long(argc, argv, short_options, long_options,
                        &opt_ix)) != -1)
    {
        if (c == '?')
        {
            fputs("Skipping unknown option.", stderr);
            continue;
        }

        cmd_ptr = ngc_command_new(c, optarg);
        current = calloc(1, sizeof(struct ngc_command_list_node));
        current->cmd_ptr = cmd_ptr;
        list_add_tail(&current->list, &ngc_commands.list);
    }

    list_for_each_entry(current, &ngc_commands.list, list)
    {
        process_command(current->cmd_ptr);
    }

    return 0;
}
