#!/usr/bin/python
import re,sys

def mkmarshaler(name, members,sname=None):
    l = { 'need_ret': False }
    if sname == None:
        sname = name
    decstr = ("int ngcs_marshal_" + name + "(" + sname +
               "* s, ngcs_data* dat, int max)")
    initstr = decstr+ "\n{\n    int cnt = 0;\n"
    decstr += ";\n"
    process_str = ""
    for m in members:
        l['m'] = m
        process_str += process("""
#if m[0] in ("string","int","long","blob")
    if(dat)
    {
        if(cnt >= max) return -1;
#if m[0] == "string" and len(m) == 2
        if(s->@m[1]@)
        {
            dat[cnt].type = NGCS_TYPE_STRING;
            dat[cnt].size = -1; dat[cnt].d.s = (char*)s->@m[1]@;
        }
        else
        {
            dat[cnt].type = NGCS_TYPE_NONE; dat[cnt].size = 0;
        }
#elif (m[0] in ("string","blob")) and len(m) == 3
        if(s->@m[1]@)
        {
            dat[cnt].size = s->@m[2]@;
#if m[0] == "string"
            dat[cnt].type = NGCS_TYPE_STRING;
            dat[cnt].d.s = (char*)s->@m[1]@;
#else
            dat[cnt].type = NGCS_TYPE_BLOB;
            dat[cnt].d.p = s->@m[1]@;
#endif
        }
        else
        {
            dat[cnt].type = NGCS_TYPE_NONE; dat[cnt].size = 0;
        }

#elif m[0] == "int" and len(m) == 2
        dat[cnt].type = NGCS_TYPE_INT;
        dat[cnt].d.i = s->@m[1]@;
#elif m[0] == "long" and len(m) == 2
        dat[cnt].type = NGCS_TYPE_LONG;
        dat[cnt].d.l = s->@m[1]@;
#else
#exec  raise Exception, "Bad structure specifier"
#endif
    }
    cnt++;
#elif m[0] in ("ignore","ignore*")
#else
#if m[0][-1] == "*"
#exec isptr = True; sp = "    "
#exec typename = m[0][:-1]; need_ret = True
#else
#exec isptr = False; sp = ""
#exec typename = m[0]; need_ret = True
#endif
    if(dat && cnt >= max) return -1;
#if isptr
    if(s->@m[1]@)
    {
#endif
    @sp@if(dat)
    @sp@    dat[cnt].type = NGCS_TYPE_GROUP;
    @sp@cnt++;
#if isptr
    @sp@ret = ngcs_marshal_@typename@(s->@m[1]@, (dat?dat+cnt:NULL), max-cnt);
#else
    @sp@ret = ngcs_marshal_@typename@(&s->@m[1]@, (dat?dat+cnt:NULL), max-cnt);
#endif
    @sp@if(ret < 0) return ret;
    @sp@if(dat) dat[cnt-1].d.i = ret;
    @sp@cnt += ret;
#if isptr
    }
    else if(dat)
    {
        dat[cnt].type = NGCS_TYPE_NONE; dat[cnt].size = 0;
        cnt++;
    }
    else cnt++;
#endif
#endif
""", l)
    process_str += "    return cnt;\n"
    if l['need_ret']:
        initstr += "    int ret;\n"
    return (decstr, initstr+"\n"+process_str+"}\n\n")

# FIXME: broken by changes in marshaller
def mkunmarshaler(name, members,sname=None):
    l = { 'need_ret': False }
    if sname == None:
        sname = name
    decstr = ("int ngcs_unmarshal_" + name + "(" + sname +
               "* s, ngcs_data* dat, int max)")
    initstr = decstr+ "\n{\n    int cnt = 0;\n\n"
    decstr += ";\n"
    process_str = ""
    for m in members:
        l['m'] = m
        process_str += process("""
#if m[0] in ("string","int","long","blob")
    if(cnt >= max) return -1;
#if m[0] == "string" and len(m) == 2
    if(dat[cnt].type == NGCS_TYPE_NONE)
        s->@m[1]@=0;
    else if(dat[cnt].type == NGCS_TYPE_STRING)
        s->@m[1]@=dat[cnt].d.s;
    else return -1;
#elif (m[0] in ("string","blob")) and len(m) == 3
    if(dat[cnt].type == NGCS_TYPE_NONE)
    {
        s->@m[1]@ = 0; s->@m[2]@ = 0;
    }
#if m[0] == "blob"
    else if(dat[cnt].type == NGCS_TYPE_BLOB)
    {
        s->@m[1]@ = dat[cnt].d.p;
#else
    else if(dat[cnt].type == NGCS_TYPE_STRING)
    {
        s->@m[1]@ = dat[cnt].d.s;
#endif
        s->@m[2]@ = dat[cnt].size;
    }
    else return -1;
#elif m[0] == "int" and len(m) == 2
    if(dat[cnt].type == NGCS_TYPE_INT)
        s->@m[1]@=dat[cnt].d.i;
    else return -1;
#elif m[0] == "long" and len(m) == 2
    if(dat[cnt].type == NGCS_TYPE_LONG)
        s->@m[1]@=dat[cnt].d.l;
    else return -1;
#else
#exec raise Exception, "Bad structure specifier"
#endif 
    cnt++;
#elif m[0] == "ignore"
#elif m[0] == "ignore*"
    s->@m[1]@=0;
#elif m[0][-1] == "*"
#exec raise Exception, "No pointer handling"
#else
#exec need_ret = True; typename = m[0]
    if(cnt >= max) return -1;
    if(dat[cnt].type != NGCS_TYPE_GROUP) return -1;
    if(dat[cnt].d.i >= max-cnt-1) return -1;
    cnt++;
    ret = ngcs_unmarshal_@typename@(&s->@m[1]@, dat+cnt, dat[cnt-1].d.i);
    if(ret < 0) return ret;
    cnt += dat[cnt-1].d.i;
#endif
""", l)
    process_str += "    return cnt;\n"
    if l['need_ret']:
        initstr += "    int ret;\n"
    return (decstr, initstr+"\n"+process_str+"}\n\n")

_head_re = re.compile(r"^\s*#header-code\s*$")
_head_end_re = re.compile(r"^\s*#end-header-code\s*$")

#FIXME - won't work due to greedy matching
_marshal_re = re.compile(r"^\s*#marshal(?:\(([^)]*)\))?\s+(.*?)\s*$")
_marshal_sp_re = re.compile(r"^(.*)\s+(.*)$")
_marshal_end_re = re.compile(r"^\s*#end-marshal\s*$")
_comment_re = re.compile(r"^\s*(?:#|//).*$")

_cmd_re = re.compile(r"^\s*#(if|elif|else|endif|exec)(?:\s+(\S.*?))?\s*$")
def process(s, l):
    prevs = ""
    stk = [ ] # list of [ active process_else ] 
    while s != prevs:
        prevs = s; outs = ""
        while s != "":
            at_p = s.find('@')
            nl_p = s.find('\n')
            if at_p >= 0 and ( nl_p < 0 or at_p < nl_p):
                if len(stk) == 0 or stk[-1][0]:
                    outs += s[:at_p]
                at2_p = s.find('@',at_p+1)
                if at2_p < 0:
                    raise ValueError, "Unmatched @"
                exp = s[at_p+1:at2_p]; s = s[at2_p+1:]
                if exp == "":
                    if len(stk) == 0 or stk[-1][0]:
                        outs += "@@"
                    continue
                if len(stk) == 0 or stk[-1][0]:
                    outs += eval(exp, globals() ,l)
            elif nl_p >= 0:
                # FIXME: doesn't work at start of string
                if len(stk) == 0 or stk[-1][0]:
                    outs += s[:nl_p+1];
                s = s[nl_p+1:]
                while True:
                    sp = s.split("\n",1)
                    if len(sp) < 2:
                        line = s; rest = ""
                    elif len(sp) == 2:
                        line = sp[0]; rest = sp[1]
                    else:
                        raise Exception
                    m = _cmd_re.match(line)
                    if m == None:
                        break
                    s = rest
                    cmd = m.group(1); exp = m.group(2)
                    if cmd == "if":
                        if len(stk) == 0 or stk[-1][0]:
                            res = eval(exp, globals() ,l)
                            stk.append([bool(res), not bool(res)])
                        else:
                            stk.append([False,False])
                    elif cmd == "elif":
                        if stk[-1][1]:
                            res = eval(exp, globals() ,l)
                            stk[-1] = [bool(res), not bool(res)]
                        else:
                            stk[-1] = [False,False]
                    elif cmd == "else":
                        stk[-1] = [stk[-1][1], False]
                    elif cmd == "endif":
                        stk.pop()
                    elif cmd == "exec":
                        if exp == None:
                            raise Exception, "No multi-line #exec yet"
                        else:
                            if len(stk) == 0 or stk[-1][0]:
                                exec exp in globals(), l
                    else:
                        raise ValueError, "Unknown cmd %s" % cmd
            else:
                outs += s; s = ""
        s = outs
    return outs.replace("@@","@")

def build(fname, hfpath=None):
    if hfpath == None:
        hfpath = fname+".h"
    infile = file(fname+".ngci","r")
    hfile = file(fname+".h","w")
    cfile = file(fname+".c","w")
    hfile.write("/* Automagically generated - do not modify */\n\n")
    hfile.write('#include "ngcs_common.h"\n\n')
    cfile.write("/* Automagically generated - do not modify */\n\n")
    cfile.write('#include "' + hfpath + '"\n\n')
    state = None; data = [ ]
    for l in infile.readlines():
        if state == None:
            m = _marshal_re.search(l)
            if m != None:
                flags = m.group(1)
                if flags == None:
                    flags = ( )
                else:
                    flags = flags.split(",")
                funcname = m.group(2)
                m = _marshal_sp_re.match(funcname)
                if m:
                    funcname = m.group(2)
                    sname = m.group(1)
                else:
                    sname = funcname
                state = "marshal"; data = [ ]
            elif _head_re.search(l):
                state = "head"
            else:
                cfile.write(l)
        elif state == "head":
            if _head_end_re.search(l):
                state = None 
            else:
                hfile.write(l)
        elif state == "marshal":
            if _marshal_end_re.search(l):
                if not ("nomarshaler" in flags):
                    (decl,defn) = mkmarshaler(funcname,data,sname)
                    hfile.write(decl); cfile.write(defn);                
                if not ("nounmarshaler" in flags):
                    (decl,defn) = mkunmarshaler(funcname,data,sname)
                    hfile.write(decl); cfile.write(defn);                
                state = None 
            elif _comment_re.search(l):
                pass
            else:
                tmp = l.split()
                if len(tmp) > 0:
                    data.append(tmp)
    cfile.close(); hfile.close(); infile.close()
    
if __name__=="__main__":
    build(sys.argv[1])
