import socket,sys,struct
from types import *

NGCS_TYPE_NONE = 0
NGCS_TYPE_INT = 1
NGCS_TYPE_STRING = 2
NGCS_TYPE_BLOB = 3
NGCS_TYPE_LONG = 4
NGCS_TYPE_GROUP = 5

SIZEOF_INT = struct.calcsize("@i")

sock = 0;

def connect():
    global sock;
    sock = socket.socket(socket.AF_UNIX,socket.SOCK_STREAM)
    sock.connect("/dev/initng/initng.ngcs")
    sys.stderr.write("Connected!\n")
    sock.settimeout(30.0)

def writemsg(chan, data):
    if not (isinstance(chan,IntType) and
            isinstance(data,(TupleType,ListType))):
        raise TypeError
    data = _flatten(data)
    sock.sendall(struct.pack("@ii",chan,len(data)))
    for datum in data:
        if isinstance(datum, IntType):
            sock.sendall(struct.pack("@iii",NGCS_TYPE_INT,SIZEOF_INT,datum))
        elif isinstance(datum, StringType):
            sock.sendall(struct.pack("@ii",NGCS_TYPE_STRING,len(datum))+datum)
        elif isinstance(datum, NgcsData):
            sock.sendall(struct.pack("@ii",datum.typecode,len(datum.data))+
                         datum.data)
        else:
            raise TypeError

def _flatten(data):
    newdata = [ ]
    for i in data:
        if isinstance(data,(TupleType,ListType)):
            t = _flatten(i)
            newdata.append(NgcsData(NGCS_TYPE_GROUP,struct.pack("@i",len(t))))
            newdata.extend(t)
        else:
            newdata.append(i)
    return newdata

def readmsg():
    (chan, cnt) = struct.unpack("@ii",recvall(2*SIZEOF_INT))
    if cnt < 0:
        return (chan, cnt)
    return (chan, _readdata(cnt))

class NgcsData:
    def __init__(self,t,d):
        self.typecode = t
        self.data = d
    def __repr__(self):
        return "NgcsData("+repr(self.typecode)+", "+repr(self.data)+")"

def _readdata(cnt):
    data = [ ]; i = 0
    while i < cnt:
        (typecode, length) = struct.unpack("@ii",recvall(2*SIZEOF_INT))
        if length < 0:
            raise IOError, "Got bad data from server"
        buf = recvall(length)
        if typecode == NGCS_TYPE_INT:
            data.append(struct.unpack("@i",buf)[0]); i += 1
#        elif typecode == NGCS_TYPE_LONG:
#            data.append(struct.unpack("@l",buf)[0]); i += 1
        elif typecode == NGCS_TYPE_STRING:
            data.append(buf); i += 1
        elif typecode == NGCS_TYPE_GROUP:
            subcnt = struct.unpack("@i",buf)[0]; i += 1
            if subcnt < 0 or subcnt > (cnt - i):
                raise IOError, "Got bad group size"
            data.append(_readdata(subcnt)); i += subcnt
        else:
            data.append(NgcsData(typecode, buf)); i += 1
    return tuple(data)
    

def recvall(amt):
    buf = ""
    while len(buf) < amt:
        data = sock.recv(amt - len(buf))
        if len(data) == 0:
            raise IOError, "End of file"
        buf += data
    return buf

def ez_cmd(*data):
    sock.settimeout(None)
    chan = 0
    writemsg(0, data)
    while True:
        msg = readmsg()
        print msg
        if chan == 0 and msg[0] == 0:
            if not isinstance(msg[1], TupleType):
                print "Channel send failure?!"; break
            elif len(msg[1]) == 0:
                pass # PONG
            elif not isinstance(msg[1][0], IntType):
                print "Bad data type!"; break
            elif msg[1][0] == 0:
                print "Command failed!"; break
            else:
                chan = msg[1][0]
                print "Opened channel %i" % chan
        elif chan != 0 and msg[0] == chan and isinstance(msg[1],IntType):
            print "---End---"; break

if __name__=='__main__':
    connect()
    writemsg(0,("watch","daemon/agetty/5"))
    while True:
        print readmsg()
