#ifndef NGCS_COMMON_H
#define NGCS_COMMON_H
#include "../../initng-paths.h"

#define SOCKET_ROOTPATH      DEVDIR "/initng/"
#define SOCKET_FILENAME_REAL SOCKET_ROOTPATH "initng.ngcs"
#define SOCKET_FILENAME_TEST SOCKET_ROOTPATH "initng-test.ngcs"

#define NGCS_TYPE_NONE 0
#define NGCS_TYPE_INT 1
#define NGCS_TYPE_STRING 2
#define NGCS_TYPE_BLOB 3
#define NGCS_TYPE_LONG 4
#define NGCS_TYPE_GROUP 5

typedef struct ngcs_data_s
{
    int type;
    int size;
    union
    {
        int i;
        long l;
        char *s;
        void *p;
    } d;
} ngcs_data;


int ngcs_sendall(int sock, const void *buf, int len);
int ngcs_recvall(int sock, void *buf, int len);
int ngcs_writemsg(int sock, int chan, ngcs_data * data, int cnt);
int ngcs_readmsg(int sock, int *chan, ngcs_data ** data, int *cnt);
void ngcs_freedata(ngcs_data * data, int cnt);
#endif
