
/* Initng, a next generation sysvinit replacement.
 * Copyright (C) 2005 Jimmy Wennlund <jimmy.wennlund@gmail.com>
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General
 * Public License along with this library; if not, write to the
 * Free Software Foundation, Inc., 59 Temple Place, Suite 330,
 * Boston, MA 02111-1307, USA.
 */

#ifndef SERVICE_DATA_TYPES_H
#define SERVICE_DATA_TYPES_H

#include "initng_service_types.h"
#include "initng_list.h"


typedef enum
{
    U_D_T = 0,
    STRING = 1,
    STRINGS = 2,
    SET = 3,
    INT = 6,
    ALIAS = 7,
    VARIABLE_STRING = 51,
    VARIABLE_STRINGS = 52,
    VARIABLE_SET = 53,
    VARIABLE_INT = 56
} e_dt;

typedef struct ss_entry s_entry;
struct ss_entry
{
    /* set in staticly */
    const char *opt_name;
    e_dt opt_type;
    stype_h *ot;
    const char *opt_desc;
    s_entry *alias;

    /* this shud not be set static */
    int opt_name_len;
    struct list_head list;
};

void initng_service_data_types_add(s_entry * ent);
void initng_service_data_types_del(s_entry * ent);
s_entry *initng_service_data_types_find(const char *string);
void initng_service_data_types_free_all(void);

#define while_service_data_types(current) list_for_each_entry_prev(current, &g.option_db.list, list)
#define while_service_data_types_safe(current, safe) list_for_each_entry_prev_safe(current, safe, &g.option_db.list, list)

#endif
