#include <CUnit/CUnit.h>
#include <CUnit/Basic.h>

#include <stdlib.h>
#include <string.h>
#include <stdio.h>

#include "test_initng.h"
#include "../src/initng_global.h"

int test_argc;
char **test_argv;
char **test_env;

int empty_init(void)
{
    return 0;
}

int empty_cleanup(void)
{
    return 0;
}

void initng_fake_new(void)
{
    char **argv, **env;
    argv = (char **) calloc(10, sizeof(char *));
    env = (char **) calloc(10, sizeof(char *));
    argv[0] = strdup("initng-fake");
    argv[1] = strdup("sample-opt");
    argv[2] = NULL;
    env[0] = ("INITNG=FAKE");
    env[1] = NULL;

    initng_global_new(1, argv, env);
}

int main(int argc, char *argv[], char *env[])
{
    test_argc = argc;
    test_argv = argv;
    test_env = env;

    CU_BasicRunMode mode = CU_BRM_VERBOSE;

    CU_initialize_registry();


    /*test_initng_toolbox_setup();
       test_process_db_setup();
       test_open_read_close_setup();
       test_initng_load_module_setup();
       test_initng_struct_data_setup(); */
    test_initng_string_tools_setup();

    /*CU_automated_run_tests(); */
    CU_basic_set_mode(mode);
    CU_basic_run_tests();

    CU_cleanup_registry();

    return 0;
}
